﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region
'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=\%PROJECT_NAME%.zip
'B4A ide://run?file=%WINDIR%\System32\cmd.exe&Args=/c&Args=start&Args=..\..\B4A\%PROJECT_NAME%.b4a
'B4i ide://run?file=%WINDIR%\System32\cmd.exe&Args=/c&Args=start&Args=..\..\B4i\%PROJECT_NAME%.b4i
'B4J ide://run?file=%WINDIR%\System32\cmd.exe&Args=/c&Args=start&Args=..\..\B4J\%PROJECT_NAME%.b4j

Sub Process_Globals

	
End Sub

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	

End Sub

Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
	
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	
	Root = Root1
	Root.LoadLayout("MainPage")
	'xui.SetDataFolder("kvs")
	'put a "simple" value
	Starter.kvs.Put("time", DateTime.Now)
	'fetch this value
	Log(DateTime.Time(Starter.kvs.Get("time")))
	Log(Starter.kvs.Get("doesn't exist"))
	Log(Starter.kvs.GetDefault("doesn't exist", 10))
	'put a Bitmap
	Starter.kvs.PutBitmap("bitmap1", LoadBitmap(File.DirAssets, "smiley.gif"))
	'fetch a bitmap
	'Activity.SetBackgroundImage(Starter.kvs.GetBitmap("bitmap1"))
	'remove the bitmap from the store
	'Starter.kvs.Remove("bitmap1")
	'put an array with two custom types
	Starter.kvs.Put("2 custom types", Array(CreateCustomType(1, "one"), CreateCustomType(2, "two")))
	'get them
	Dim mytypes() As Object = Starter.kvs.Get("2 custom types") 'the array type must be object or bytes
	Dim ct1 = mytypes(0), ct2 = mytypes(1) As MyCustomType
	Log($""${ct1}"$)
	Log($""${ct2}"$)
	'add a collection
	Dim list1 As List
	list1.Initialize
	For i = 1 To 10
		list1.Add("Item #" & i)
	Next
	Starter.kvs.Put("list1", list1)
	
	'fetch the collection
	Dim list2 As List = Starter.kvs.Get("list1")
	Log($""${list2}"$)
	'encrypt the list
	Starter.kvs.PutEncrypted( "encrypted list", list1, "topsecret")
	Try
		Log("An error message will be printed in debug mode...")
		list2 = Starter.kvs.GetEncrypted("encrypted list", "wrong password")
	Catch
		Log("Wrong password!")
	End Try
	list2 = Starter.kvs.GetEncrypted("encrypted list", "topsecret")
	Log($""${list2}"$)
	Dim map As Map = CreateMap("aaa": 100, "bbb": 200)
	Wait For (Starter.kvs.PutMapAsync(map)) Complete (Success As Boolean)
	Log("Success: " & Success)
	Wait For (Starter.kvs.GetMapAsync(Starter.kvs.ListKeys)) Complete (Result As Map)
	Log($""${Result}"$)
	Dim mytypes() As Object = Result.Get("2 custom types")
	Log(DateTime.Time(Result.Get("time")))
	
	
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Private Sub CreateCustomType(Number As Int, Text As String) As MyCustomType
	Dim ct As MyCustomType
	ct.Initialize
	ct.Number = Number
	ct.Text = Text
	Return ct
End Sub